package statej.ast;

import statej.Visitor;

import statej.typeChecker.Modifier;
import statej.utils.ParamUtils;

/**
 * <p>Title: Programming mini project 2 Java-- compiler</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004 NIcholas Cameron</p>
 * <p>Company: </p>
 * @author Nicholas Cameron
 * @version 1.0
 */

public class ConstructorNode extends MethodNode
{
    public ConstructorNode(String name, ListNode params, Modifier access, CompoundNode body, int lineNumber, int colNumber)
    {
        super(name, params, access, "void", false, body, lineNumber, colNumber);
    }

    public Object accept(Visitor v)
    {
        return v.visit(this);
    }

    public String toString()
    {
        return access + " " + name + "(" + ParamUtils.makeSourceList(params) + ")";
    }

    public String getType()
    {
        return "void";
    }
    public String eol()
    {
    	throw new RuntimeException("non-promotable expression");
    }
}