package statej.ast;

import statej.Visitor;

public class ImportNode extends Node
{
	protected String importString;
	public ImportNode(String importString, int rowNumber, int colNumber)
	{
		super(rowNumber, colNumber);
		this.importString = importString;
	}
	
	public Object accept(Visitor v)
	{
		return v.visit(this);
	}

	public String getImportString()
	{
		return importString;
	}
	
	public String toString()
	{
		return "import " + importString;
	}
	
    public String eol()
    {
    	throw new RuntimeException("non-promotable expression");
    }
}
