package statej.typeChecker;

import statej.ast.Node;

/**
 * <p>Title: Programming mini project 2 Java-- compiler</p>
 * <p>Description: Symbol table enrty for a field in a class</p>
 * <p>Copyright: Copyright (c) 2004 NIcholas Cameron</p>
 * <p>Company: </p>
 * @author Nicholas Cameron
 * @version 1.0
 */

public class FieldSymbol extends Symbol implements AccessSymbol
{
    //the fields access modifier (eg private)
    private Modifier access;

    //the field's unique id used in code generation
    protected int fieldNumber;

    //the class where the method is defined
    private ClassSymbol owner = null;

    /**
     * create a new symbol table entry of kind field
     * @param name the field's name
     * @param type the name of the field's type
     * @param access the fields access modifier (eg private)
     * @param decl the node where the field is declared
     */
    public FieldSymbol(String name, String type, Modifier access, Node decl)
    {
        super(name, type, decl);
        this.access = access;
    }

    public String getKind()
    {
        return "field";
    }

    public Modifier getAccessModifier()
    {
        return access;
    }
    public void setFieldNumber(int fieldNumber)
    {
        this.fieldNumber = fieldNumber;
    }
    public int getFieldNumber()
    {
        return fieldNumber;
    }
    public ClassSymbol getOwner()
    {
        return owner;
    }
    public void setOwner(ClassSymbol owner)
    {
        this.owner = owner;
    }
}