package statej.typeChecker;

import statej.ast.Node;

public class StateSymbol extends Symbol
{
    //the method's symbol table
	protected SymbolTable sTable;
    
    protected int stateNumber;
    
    public final static String KEY_PREFIX = "$$state$$";
    
    //the class where the state is defined
    private ClassSymbol owner = null;

	public StateSymbol(String name, Node node, SymbolTable st)
	{
		super(name, "void", node);
		this.sTable = st;
	}

	public String getKind()
	{
		return "state";
	}
	
    public SymbolTable getSymbolTable()
    {
        return sTable;
    }

    public void setStateNumber(int methodNumber)
    {
        this.stateNumber = methodNumber;
    }
    public int getStateNumber()
    {
        return stateNumber;
    }
    public ClassSymbol getOwner()
    {
        return owner;
    }
    public void setOwner(ClassSymbol owner)
    {
        this.owner = owner;
    }
    public String getKey()
    {
    	return KEY_PREFIX + super.getKey();
    }
}
